(function() {

    openerp.widgetInstancePaymentTermDiscount = null;
    openerp.parentInstancePaymentTermDiscount = null;
    var Qweb = openerp.web.qweb;
    var instance = openerp;
    var instanceWeb = openerp.web;

    openerp.PaymentTermDiscount = instance.Widget.extend({
        template: 'eiruPaymentTerm.Discount',
        id: undefined,

        termConfig: [],
        saleOrderInterst: [],
        saleOrder: [],

        init: function(parent) {
            this._super(parent);
            this.buttons = parent.$buttons;
        },
        start: function() {
            var self = this;

            this.$el.click(function(){
                self.fectchInitial();
            });
            self.buttons.click(function(e) {
                /* E (Editar) */
                if (e.target.accessKey === 'E')
                    self.$el.css('display','none');
                /* S (Guarrdar) */
                if (e.target.accessKey === 'S')
                    self.$el.css('display','flex');
                /* D (Cancelar) */
                if (e.target.accessKey === 'D')
                    self.$el.css('display','flex');
                /* CREAR */
                if (e.target.accessKey === 'C')
                    self.$el.css('display','none');
            });
        },
        updateId: function(id) {
            var self = this;
            self.id = id;

            self.$el.css('display','flex');
            if (!id)
                self.$el.css('display','none');
        },
        /* Remover */
        removeModal: function() {
            $('.expired-account-modal').remove();
            $('.modal-backdrop').remove();
        },
        /* Reloada */
        reloadPage: function() {
            openerp.parentInstancePaymentTermDiscount.reload();
        },
        /* Metodo Inicial */
        fectchInitial: function() {
            var self = this;
            self.fetchSaleOrderDiscount().then(function(saleOrder) {
                return saleOrder
            }).then(function(saleOrder) {
                self.saleOrder = saleOrder;
                return self.showModalDiscount();
            });
        },

        fetchSaleOrderDiscount: function() {
            var self = this;
            var order = new openerp.web.Model('sale.order');
            return order.call('getSaleOrder',[self.id],{
                context: new openerp.web.CompoundContext()
            });
        },

        showModalDiscount: function() {
            var self = this;
            var defer = $.Deferred();
            var state = true;
            if (!self.saleOrder.length)
                return

            var order = self.saleOrder[0];
            var currency = order.currency;

            /* Modal */
            var modal = Qweb.render('eiruPaymentTerm.ModalDiscount');
            $('.openerp_webclient_container').after(modal);
            $('.expired-account-modal').modal();

            var dateSale = $('.expired-account-modal').find('.date-sale-discount');
            // var dateQuotaInterest = $('.expired-account-modal').find('.date-quota-interest');
            var amountSale = $('.expired-account-modal').find('.amount-sale');
            var amountDiscount = $('.expired-account-modal').find('.amount-discount');
            var amountTotal = $('.expired-account-modal').find('.amount-total');
            var symbolCurrencyInterest = $('.expired-account-modal').find('.symbol-currency-interest');
            var buttonAcceptDiscount = $('.expired-account-modal').find('.button-accept-discount');

            /*--------------
                Inicial.
            ----------------*/
            dateSale.val(moment(order.dateOrder).format('DD/MM/YYYY'));
            amountSale.val(instanceWeb.formatCurrency(order.amountTotal, currency));
            amountDiscount.val(0);
            amountTotal.val(instanceWeb.formatCurrency(order.amountTotal, currency));
            symbolCurrencyInterest.text(currency.symbol);
            buttonAcceptDiscount.attr("disabled", true)

            /*--------------------------
                FOCUSIN amountDiscount
            ----------------------------*/
            amountDiscount.focusin(function(e) {
                var amount = instanceWeb.unFormatCurrency( amountDiscount.val());
                if (amount === 0)
                    amountDiscount.val('');
            });
            /*-----------------------
                KEYUP amountDiscount
            ------------------------*/
            amountDiscount.keyup(function(e) {
                var discountAmount = instanceWeb.unFormatCurrency(amountDiscount.val());
                var amountReal = instanceWeb.unFormatCurrency(amountSale.val());

                if (e.key === currency.decimalSeparator && currency.decimalPlaces > 0)
                 return false ;

                if (discountAmount > amountReal){
                    instanceWeb.notification.do_warn("Atencion", "El valor del descuento superar el valor total de la venta.");
                    amountDiscount.focus();
                    return false
                }

                amountDiscount.val(instanceWeb.formatCurrency(discountAmount, currency));
                amountTotal.val(instanceWeb.formatCurrency((amountReal - discountAmount), currency))

                if (e.keyCode === 13) {
                    if (discountAmount > amountReal) {
                        buttonAcceptDiscount.attr("disabled", true);
                        amountDiscount.focus();
                        return false
                    }

                    buttonAcceptDiscount.removeAttr("disabled");
                    buttonAcceptDiscount.focus()
                  }
            });
            /*---------------------------
                FOCUS OUT amountDiscount
            ----------------------------*/
            amountDiscount.focusout(function(e) {
                var discountAmount = instanceWeb.unFormatCurrency(amountDiscount.val());
                var amountReal = instanceWeb.unFormatCurrency(amountSale.val());

                if (discountAmount > amountReal) {
                    instanceWeb.notification.do_warn("Atencion", "El valor del descuento superar el valor total de la venta.");
                    buttonAcceptDiscount.attr("disabled", true);
                    amountDiscount.focus();
                    return false;
                }
                if (discountAmount <= 0){
                    buttonAcceptDiscount.attr("disabled", true);
                    return false;
                }
                buttonAcceptDiscount.removeAttr("disabled");
            });
            /*-------------
                Guardar.
            -------------- */
            buttonAcceptDiscount.click(function(e){
                var discountAmount = instanceWeb.unFormatCurrency(amountDiscount.val());
                var amountReal = instanceWeb.unFormatCurrency(amountSale.val());
                var amount = instanceWeb.unFormatCurrency(amountTotal.val());

                if (discountAmount > amountReal) {
                    instanceWeb.notification.do_warn("Atencion", "El valor del descuento superar el valor total de la venta.");
                    buttonAcceptDiscount.attr("disabled", true);
                    amountDiscount.focus();
                    return false;
                }
                if (discountAmount <= 0){
                    buttonAcceptDiscount.attr("disabled", true);
                    return false;
                }


                $('.expired-account-modal').find('.widget-content.widget-loading-term-configurator').css('display','flex');
                self.accountSaleLineAddDiscount(self.id, amount).then(function(saleDiscont) {
                    return saleDiscont;
                }).then(function(saleDiscont) {
                    $('.expired-account-modal').find('.widget-content.widget-loading-term-configurator').css('display','none');
                    self.reloadPage();
                    self.removeModal(e);
                    state = saleDiscont.state;
                });

                defer.resolve(state);
            }),

            /*-----------
                CERRAR
            -----------*/
            $('.expired-account-modal').on('hidden.bs.modal', function (e) {
                defer.resolve(false);
                self.removeModal(e);
            });

            return defer;
        },
        /* -----------------------
            Guardar Interest
        -------------------------- */
        accountSaleLineAddDiscount: function(id, amount) {
            var sale = new instance.web.Model('sale.order');
            return sale.call('account_Sale_line_add_discount',[id,amount], {
                context: new instance.web.CompoundContext()
            });
        },
    });

    if (instance.web && instance.web.FormView) {
        instance.web.FormView.include({
            load_record: function(record) {
                this._super.apply(this, arguments);

                if (this.model !== 'sale.order')
                    return;

                openerp.parentInstancePaymentTermDiscount = this;

                if (openerp.widgetInstancePaymentTermDiscount) {
                    openerp.widgetInstancePaymentTermDiscount.updateId(record.id);
                    if (this.$el.find('.button-term-discount').length !== 0){
                        return
                    }
                }

                if (this.$el.find('.button-term-discount').length !== 0 )
                    return;

                openerp.widgetInstancePaymentTermDiscount = new openerp.PaymentTermDiscount(this);
                var elemento = this.$el.find('.oe_form').find('.payment_term_discont');

                openerp.widgetInstancePaymentTermDiscount.appendTo(elemento);
                openerp.widgetInstancePaymentTermDiscount.updateId(record.id);
            },

        });
    }
})();
