(function() {

    openerp.widgetInstancePaymentTermInterest = null;
    openerp.parentInstancePaymentTermInterest = null;
    var Qweb = openerp.web.qweb;
    var instance = openerp;
    var instanceWeb = openerp.web;

    openerp.PaymentTermInterest = instance.Widget.extend({
        template: 'eiruPaymentTerm.Interest',
        id: undefined,

        termConfig: [],
        saleOrderInterst: [],

        init: function(parent) {
            this._super(parent);
            this.buttons = parent.$buttons;
        },
        start: function() {
            var self = this;

            this.$el.click(function(){
                self.fectchInitial();
            });
            self.buttons.click(function(e) {
                /* E (Editar) */
                if (e.target.accessKey === 'E')
                    self.$el.css('display','none');
                /* S (Guarrdar) */
                if (e.target.accessKey === 'S')
                    self.$el.css('display','flex');
                /* D (Cancelar) */
                if (e.target.accessKey === 'D')
                    self.$el.css('display','flex');
                /* CREAR */
                if (e.target.accessKey === 'C')
                    self.$el.css('display','none');
            });
        },
        updateId: function(id) {
            var self = this;
            self.id = id;

            self.$el.css('display','flex');
            if (!id)
                self.$el.css('display','none');
        },
        /* Remover */
        removeModal: function() {
            $('.expired-account-modal').remove();
            $('.modal-backdrop').remove();
        },
        /* Reloada */
        reloadPage: function() {
            openerp.parentInstancePaymentTermInterest.reload();
        },
        /* Metodo Inicial */
        fectchInitial: function() {
            var self = this;
            self.fetchSaleOrderInterest().then(function(saleOrderInterst) {
                return saleOrderInterst
            }).then(function(saleOrderInterst) {
                self.saleOrderInterst = saleOrderInterst;
                return self.showModalInterest();
            });
        },

        fetchSaleOrderInterest: function() {
            var self = this;
            var order = new openerp.web.Model('sale.order');
            return order.call('getSaleOrderInterest',[self.id],{
                context: new openerp.web.CompoundContext()
            });
        },
        showModalInterest: function() {
            var self = this;
            var defer = $.Deferred();
            var state = true;
            if (!self.saleOrderInterst.length)
                return

            var order = self.saleOrderInterst[0];
            var currency = order.currency;

            /* Modal */
            var modal = Qweb.render('eiruPaymentTerm.ModalInterest');
            $('.openerp_webclient_container').after(modal);
            $('.expired-account-modal').modal();

            var dateSaleInterest = $('.expired-account-modal').find('.date-sale-interest');
            var dateQuotaInterest = $('.expired-account-modal').find('.date-quota-interest');
            var dayDifference = $('.expired-account-modal').find('.day-difference');
            var amountInterest = $('.expired-account-modal').find('.amount-interest');
            var symbolCurrencyInterest = $('.expired-account-modal').find('.symbol-currency-interest');
            var buttonAcceptInterest = $('.expired-account-modal').find('.button-accept-interest');

            /*--------------
                Inicial.
            ----------------*/
            dateSaleInterest.val(moment(order.dateOrder).format('DD/MM/YYYY'));
            dateQuotaInterest.val(moment(order.dateQuota).format('DD/MM/YYYY'));
            dayDifference.val(order.differenceDay);
            amountInterest.val(instanceWeb.formatCurrency(order.amountInteres, currency));
            symbolCurrencyInterest.text(currency.symbol);

            /*-------------
                Guardar.
            -------------- */
            buttonAcceptInterest.click(function(e){
                var interest ={
                    'amountTotal' : order.amountTotal,
                    'dateOrder' : order.dateOrder,
                    'dateQuota' : order.dateQuota,
                    'amountInteres' : order.amountInteres,
                    'differenceDay' : order.differenceDay,
                    'messageDefault' : order.messageDefault,
                    'saleId': self.id,
                }
                $('.expired-account-modal').find('.widget-content.widget-loading-term-configurator').css('display','flex');
                self.accountSaleInterest(interest).then(function(saleInterest) {
                    return saleInterest;
                }).then(function(saleInterest) {
                    $('.expired-account-modal').find('.widget-content.widget-loading-term-configurator').css('display','none');
                    self.reloadPage();
                    self.removeModal(e);
                    state = saleInterest.state;
                });

                defer.resolve(state);
            }),

            /*-----------
                CERRAR
            -----------*/
            $('.expired-account-modal').on('hidden.bs.modal', function (e) {
                defer.resolve(false);
                self.removeModal(e);
            });

            return defer;
        },
        /* -----------------------
            Guardar Interest
        -------------------------- */
        accountSaleInterest: function(interest) {
            var term = new instance.web.Model('sale.order');
            return term.call('account_sale_line_interest',[interest], {
                context: new instance.web.CompoundContext()
            });
        },
    });

    if (instance.web && instance.web.FormView) {
        instance.web.FormView.include({
            load_record: function(record) {
                this._super.apply(this, arguments);

                if (this.model !== 'sale.order')
                    return;

                openerp.parentInstancePaymentTermInterest = this;

                if (openerp.widgetInstancePaymentTermInterest) {
                    openerp.widgetInstancePaymentTermInterest.updateId(record.id);
                    if (this.$el.find('.button-term-interest').length !== 0){
                        return
                    }
                }

                if (this.$el.find('.button-term-interest').length !== 0 )
                    return;

                openerp.widgetInstancePaymentTermInterest = new openerp.PaymentTermInterest(this);
                var elemento = this.$el.find('.oe_form').find('.payment_term_configurator');

                openerp.widgetInstancePaymentTermInterest.appendTo(elemento);
                openerp.widgetInstancePaymentTermInterest.updateId(record.id);
            },

        });
    }
})();
